/*---------------------------------------------------------------------------------
 BroamRelay ( 2004 Slade Taylor [bladestaylor@yahoo.com])
 ----------------------------------------------------------------------------------
 BroamRelay is a plugin for Blackbox for Windows.  For more information,
 please visit [http://bb4win.org] or [http://sourceforge.net/projects/bb4win].
 ----------------------------------------------------------------------------------
 BroamRelay is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

#define VC_EXTRALEAN
#include "../Blackbox/BBApi.h"

#define MAX_BR_PATH         4096
#define BR_CLASSNAME        "BroamRelay"

//-------------------------------------------------------------------------------------

static FILE *br_file;
static HWND hCoreWnd, hBRWnd;
static char *br_path, br_buffer[MAX_BR_PATH];
static int bb_messages[] = {BB_BROADCAST, 0};

//-------------------------------------------------------------------------------------

extern "C"
{
    __declspec(dllexport) int beginPlugin(HINSTANCE);
    __declspec(dllexport) void endPlugin(HINSTANCE);
    __declspec(dllexport) LPCSTR pluginInfo(int);
}

//-------------------------------------------------------------------------------------

LRESULT CALLBACK brProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
    if ((msg == BB_BROADCAST) && 
        !strncmp(br_path = (char*)lp, "@BroamRelay ", 12) && 
        (br_file = FileOpen(br_path + 12)))
    {
        while (ReadNextCommand(br_file, br_buffer, 1024))
            SendMessage(hCoreWnd, BB_BROADCAST, NULL, (LPARAM)br_buffer);
        return FileClose(br_file);
    }
    return DefWindowProc(hwnd, msg, wp, lp);
}

//-------------------------------------------------------------------------------------

int beginPlugin(HINSTANCE hPluginInstance)
{
    WNDCLASS wc;
    ZeroMemory((void*)&wc, sizeof(wc));
    wc.lpszClassName = BR_CLASSNAME;
    wc.hInstance = hPluginInstance;
    wc.lpfnWndProc = brProc;
    RegisterClass(&wc);

    hBRWnd = CreateWindowEx(
        WS_EX_TOOLWINDOW,
        BR_CLASSNAME,
        NULL,
        WS_POPUP,
        0, 0, 0, 0,
        HWND_MESSAGE,
        NULL,
        hPluginInstance,
        NULL
    );

    SendMessage(hCoreWnd = GetBBWnd(), BB_REGISTERMESSAGE, (WPARAM)hBRWnd, (LPARAM)bb_messages);
    return 0;
}

//-------------------------------------------------------------------------------------

void endPlugin(HINSTANCE hPluginInstance)
{
    SendMessage(hCoreWnd, BB_UNREGISTERMESSAGE, (WPARAM)hBRWnd, (LPARAM)bb_messages);
    DestroyWindow(hBRWnd);
    UnregisterClass(BR_CLASSNAME, hPluginInstance);
}

//-------------------------------------------------------------------------------------

LPCSTR pluginInfo(int field)
{
    switch (field)
    {
        case 2:     return "0.001";
        case 3:     return "bladestaylor";
        case 4:     return "March 2, 2004";
        case 5:     return "";
        case 6:     return "bladestaylor@yahoo.com";
        default:    return BR_CLASSNAME;
    }
}

//-------------------------------------------------------------------------------------
